From balsoy@nova.npac.syr.edu Mon Nov 24 18:59 EST 1997
Received: from nova.npac.syr.edu (nova.npac.syr.edu [128.230.51.195]) by postoffice.npac.syr.edu (8.7.5/8.7.1) with ESMTP id SAA28001 for <msen7@postoffice.npac.syr.edu>; Mon, 24 Nov 1997 18:59:54 -0500 (EST)
Received: (from balsoy@localhost)
	by nova.npac.syr.edu (8.8.5/8.8.5) id SAA07534
	for msen7; Mon, 24 Nov 1997 18:59:52 -0500 (EST)
Date: Mon, 24 Nov 1997 18:59:52 -0500 (EST)
From: Ozgur Balsoy <balsoy@npac.syr.edu>
Message-Id: <199711242359.SAA07534@nova.npac.syr.edu>
To: msen7@nova.npac.syr.edu
Content-Type: text
Content-Length: 3015
X-Status: 
Status: RO

import java.awt.*;
import java.applet.*;
import java.lang.*;

public class obUI extends Applet {

    int MaxDigits=100,EachTerm=4;
    String zeros="";
    
    TextArea top;
    String term1="0", term2="0";
    boolean firstTerm=true, clear=true;

    public void init() {
	setLayout(new BorderLayout());

	top=new TextArea(1,MaxDigits*2);
	top.setText("0");
	add("North", top);

	Panel p = new Panel();
	add("Center", p);
	p.setLayout(new GridLayout(4, 3));

	int i;
	for(i=0; i<12; i++) 
		p.add(new Button("7894561230X=".substring(i,i+1)));

	for(i=0; i<EachTerm; i++) zeros=zeros+"0";
    }

    public boolean action(Event evt, Object arg) {
	String s=(String)arg;
	
	if("0123456789".indexOf(s) != -1) newDigit(s);
	else if(s.equals("X")) newNumber();
	else if(s.equals("=")) finishMultiply();

	return true;
    }

    public void newDigit(String s) {
	if(top.getText()=="") top.setText("0");
	if(Integer.parseInt(top.getText())==0) {
		top.setText(s);
		clear=false;
	} else {
		if (clear) top.setText(s);
		else top.insertText(s, (top.getText()).length());
		clear=false;
	}
    }

    public void newNumber() {
	if(top.getText()=="") top.setText("0");
	if (firstTerm) {
		term1=top.getText();
		firstTerm=false;
	} else {
		doMultiply();
		term1=top.getText();
	}
      clear=true;
    }

    public void finishMultiply() {
		if(top.getText()=="") top.setText("0");
		doMultiply();
		firstTerm=true;
		term1="0";
    }

    public void doMultiply() {
		int MaxTerms=(int)Math.ceil(MaxDigits/(float)EachTerm);		
		int terms1[]=new int[MaxTerms], terms2[]=new int[MaxTerms];
		int results[]=new int[2*MaxTerms];
		int i, j, t1, t2, x;
		int result, carry;
		String resultStr="", s;
		boolean error=false;

		term2=top.getText();

		if(term1.length() >= MaxDigits) { term1="0"; error=true;}
		if(term2.length() >= MaxDigits) { term2="0"; error=true;}
		t1=(int)Math.floor((term1.length()-1)/(float)EachTerm);
		t2=(int)Math.floor((term2.length()-1)/(float)EachTerm);
		
		i=0;
		x=term1.length();
		while(i<t1) {
			x-=EachTerm;
			terms1[i++]=Integer.parseInt(term1.substring(x,x+EachTerm));
		}
		
		terms1[i]=Integer.parseInt(term1.substring(0,x));

		i=0;
		x=term2.length();
		while(i<t2) {
			x-=EachTerm;
			terms2[i++]=Integer.parseInt(term2.substring(x,x+EachTerm));
		}
		terms2[i]=Integer.parseInt(term2.substring(0,x));

		for(i=0; i<2*MaxTerms; i++) results[i]=0;

		for(i=0; i<=t1; i++)
			for(j=0; j<=t2; j++) {
				x=i+j;
				result=terms1[i]*terms2[j]+results[x];
				do {
					results[x]=(int)(result % Math.pow(10, EachTerm));
					carry=(int)(result/Math.pow(10, EachTerm));
					result=results[++x]+carry;
				} while (carry > 0);
			}

            for(i=t1+t2+1; i>=0 && results[i]==0; i--);
            if(i>=0) resultStr=String.valueOf(results[i--]);
            else resultStr="0";
		for(; i>=0; i--) {
			s=String.valueOf(results[i]);
			resultStr=resultStr+zeros.substring(0,EachTerm-s.length())+s;
		};
		if(error) resultStr="E";
		top.setText(resultStr);
		clear=true;
    }

}

